## ros-galactic-rt-manipulators-cpp 1.0.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

# set the project name and version
project(rt_manipulators_cpp VERSION 1.0)

# specify the C++ standard
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED True)

# add_subdirectory(src)
find_package(ament_cmake REQUIRED)
find_package(dynamixel_sdk REQUIRED)
find_package(eigen3_cmake_module REQUIRED)
find_package(Eigen3)
find_package(yaml_cpp_vendor REQUIRED)

set(library_name ${CMAKE_PROJECT_NAME})

add_library(${library_name}
    SHARED
    src/hardware.cpp
    src/joint.cpp
    src/hardware_joints.cpp
    src/hardware_communicator.cpp
    src/kinematics.cpp
    src/kinematics_utils.cpp
    src/config_file_parser.cpp
    src/dynamixel_x.cpp
    src/dynamixel_xm430.cpp
    src/dynamixel_xm540.cpp
    src/dynamixel_xh430.cpp
    src/dynamixel_xh540.cpp
    src/dynamixel_p.cpp
    src/dynamixel_ph42.cpp
)
target_include_directories(${library_name}
    PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include>)
ament_target_dependencies(${library_name}
    dynamixel_sdk
    Eigen3
    yaml_cpp_vendor
)

ament_export_targets(export_${library_name} HAS_LIBRARY_TARGET)
ament_export_dependencies(
    dynamixel_sdk
    eigen3_cmake_module
    Eigen3
    yaml_cpp_vendor
)
install(
  DIRECTORY include/
  DESTINATION include/${library_name}
)

install(
  TARGETS ${library_name}
  EXPORT export_${library_name}
  LIBRARY DESTINATION lib
  ARCHIVE DESTINATION lib
  RUNTIME DESTINATION bin
  INCLUDES DESTINATION include
)

ament_package()

=== src/CMakeLists.txt ===
find_package(yaml-cpp REQUIRED)
find_package(Threads REQUIRED)

set(library_name ${CMAKE_PROJECT_NAME})

add_library(${library_name}
    SHARED
    hardware.cpp
    joint.cpp
    hardware_joints.cpp
    hardware_communicator.cpp
    kinematics.cpp
    kinematics_utils.cpp
    config_file_parser.cpp
    dynamixel_x.cpp
    dynamixel_xm430.cpp
    dynamixel_xm540.cpp
    dynamixel_xh430.cpp
    dynamixel_xh540.cpp
    dynamixel_p.cpp
    dynamixel_ph42.cpp
)
set_target_properties(${library_name} PROPERTIES VERSION 1.1.0 SOVERSION 1)

target_include_directories(${library_name} PUBLIC
    ${PROJECT_SOURCE_DIR}/include
)
message("${CMAKE_THREAD_LIBS_INIT}")
target_link_libraries(${library_name} PUBLIC
    ${YAML_CPP_LIBRARIES}
    ${CMAKE_THREAD_LIBS_INIT}
    dxl_x64_cpp
)

install(TARGETS ${library_name}
    EXPORT ${library_name}-export
    LIBRARY DESTINATION lib
    INCLUDES DESTINATION include
    PUBLIC_HEADER DESTINATION include/${library_name}
)

install(DIRECTORY ${PROJECT_SOURCE_DIR}/include/
    DESTINATION include/${CMAKE_PROJECT_NAME})

=== test/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

# set the project name and version
project(rt_manipulators_cpp_test VERSION 1.0)

# specify the C++ standard
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED True)

enable_testing()

find_package(GTest REQUIRED)

include(GoogleTest)

# サンプルのビルド
set(list_tests
    test_joint
    test_kinematics_utils
    test_kinematics
    test_config_file_parser
    test_dynamixel_x
    test_dynamixel_xh
    test_dynamixel_p
)
foreach(test_executable IN LISTS list_tests)
    message("${test_executable}")
    add_executable(${test_executable}
        ${test_executable}.cpp
    )
    target_link_libraries(${test_executable}
        GTest::GTest
        GTest::Main
        rt_manipulators_cpp
    )
    gtest_discover_tests(${test_executable})
endforeach()

=== debian/changelog ===
ros-galactic-rt-manipulators-cpp (1.0.0-1focal) focal; urgency=high

  * ROS 2に対応 (#28 <https://github.com/rt-net/rt_manipulators_cpp/issues/28>)

 -- RT Corporation <support@rt-net.jp>  Sun, 12 Jun 2022 15:00:00 -0000

=== debian/control ===
Source: ros-galactic-rt-manipulators-cpp
Section: misc
Priority: optional
Maintainer: RT Corporation <support@rt-net.jp>
Build-Depends: debhelper (>= 9.0.0), libeigen3-dev, libyaml-cpp-dev, ros-galactic-ament-cmake, ros-galactic-ament-lint-auto <!nocheck>, ros-galactic-ament-lint-common <!nocheck>, ros-galactic-dynamixel-sdk, ros-galactic-eigen3-cmake-module, ros-galactic-yaml-cpp-vendor, ros-galactic-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-galactic-rt-manipulators-cpp
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libeigen3-dev, libyaml-cpp-dev, ros-galactic-dynamixel-sdk, ros-galactic-eigen3-cmake-module, ros-galactic-yaml-cpp-vendor, ros-galactic-ros-workspace
Description: RT Manipulators C++ Library

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/galactic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/galactic" \
		-DAMENT_PREFIX_PATH="/opt/ros/galactic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/galactic" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-galactic-rt-manipulators-cpp//opt/ros/galactic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	dh_auto_install
